package test.example;

import java.util.Map;

import org.apache.struts2.StrutsTestCase;
import org.junit.Test;

import com.opensymphony.xwork2.ActionProxy;
import com.opensymphony.xwork2.ActionSupport;

public class TypeConversionTest extends StrutsTestCase {

	private ActionProxy actionProxy;
	private ActionSupport action;

	@Test
	public void test() throws Exception{
		Entity entity = new Entity();
		entity.setId(1);
		
		super.setUp();

		request.setParameter("simpleMap[1]", "value");

		createAction("/example/Convesion.action");

		executeProxy();

		Map<Entity, String> complexMap = ((TypeConversionAction) action).getSimpleMap();
		
		assertNotNull(complexMap);
		assertFalse(complexMap.isEmpty());
		
		assertEquals("value", complexMap.get(entity));
	}

	/**
	 * Creates the action with the given actionPath if it wasn't already created
	 * 
	 * @see isAlreadyCreated
	 * 
	 * @param actionPath
	 * @throws Exception
	 */
	public ActionSupport createAction(String actionPath) throws Exception {
		actionProxy = getActionProxy(actionPath);
		action = (ActionSupport) actionProxy.getAction();
		return action;
	}
	
	/**
	 * Executes the action created and returns the result 
	 * 
	 * @return
	 * @throws Exception
	 */
	public String executeProxy() throws Exception {
		actionProxy.setExecuteResult(false);
		return actionProxy.execute();
	}


}
